from lwan_coro cimport scheduler_t, scheduler_init, scheduler_coro_add, scheduler_run, scheduler_destroy, coro_yield_value, coro_yield, coro_t
from libc.stdio cimport printf

cdef extern from "unistd.h" nogil:
  unsigned int sleep(unsigned int seconds)

cdef cypclass SomeMemory:
  int a;
  int b;
  void foo(self) nogil:
    while self.a < 4:
      self.a += 1
      printf("%d\n", self.a)
      sleep(1)
  void __init__(self, int a, int b):
    self.a = a
    self.b = b

def main():
  cdef:
    scheduler_t s
    unsigned int i

  with nogil:
    scheduler_init(&s)

    for i in range(5):
      scheduler_coro_add(&s, task)

    scheduler_run(&s)
    scheduler_destroy(&s)

# Example task
cdef int task(coro_t *coroutine, void *arg) nogil:
  cdef int a = 5
  coro_yield(coroutine, coro_yield_value.MAY_RESUME)
  cdef SomeMemory bar = SomeMemory(1, 2)
  bar.foo()
  coro_yield(coroutine, coro_yield_value.FINISHED)
